define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var org = require("$UI/LIMS/JS/organization");
	var check = require("$UI/LIMS/JS/check");
	
	var pageListCount = 20; // 每页显示数据条数
	var offset = 1; // 开始显示第几条数据
	var limit = pageListCount;// 结束显示的第几天数据
	var dataCount = 0; // 总数据条数
	var pageCount = 1; // 当前页码

	var viewflag = false;

	var Model = function() {
		this.callParent();
	};

	Model.prototype.newBtnClick = function(event) {
		var result = this.ognCheck();
		if (!result) {
			return;
		}
		var selectRow = this.comp('selectData').getCurrentRow();
		this.comp("mainFormDialog").open({
			data : {
				"type" : "new",
				"selectRow" : selectRow
			}
		});
	};

	Model.prototype.updateBtnClick = function(event) {

		var result = this.ognCheck();
		if (!result) {
			return;
		}
		var currentRowID = this.comp("tempData").getValue("currentRowID");
		if (currentRowID == "" || currentRowID == undefined) {
			this.comp("messageDialog").show({
				title : "提示",
				message : "请先选择一条数据！"
			});
			return;
		}
		var row = this.comp("showData").getCurrentRow();
		var id = row.val("FID");
		var mainData = this.comp("mainData");
		mainData.clear();
		mainData.setFilter("IDFilter", "LIMS_Check_EntrustmentMain = '" + id + "'");
		mainData.refreshData();
		if (mainData.getValue("fState") == 0) {
			var selectRow = this.comp('selectData').getCurrentRow();
			this.comp("mainFormDialog").open({
				data : {
					"type" : "edit",
					"row" : row,
					"selectRow" : selectRow
				}
			});
		} else {
			this.comp("messageDialog").show({
				title : "提示",
				message : "只有保存状态的记录可以修改！"
			});
			return;
		}
	};

	Model.prototype.delBtnClick = function(event) {
		var result = this.ognCheck();
		if (!result) {
			return;
		}
		var currentRowID = this.comp("tempData").getValue("currentRowID");
		if (currentRowID == "" || currentRowID == undefined) {
			this.comp("messageDialog").show({
				title : "提示",
				message : "请先选择一条数据！"
			});
			return;
		}
		var row = this.comp("showData").getCurrentRow();
		var id = row.val("FID");
		var mainData = this.comp("mainData");
		mainData.clear();
		mainData.setFilter("IDFilter", "LIMS_Check_EntrustmentMain = '" + id + "'");
		mainData.refreshData();
		if (mainData.getValue("fState") == 0) {
			mainData.deleteData();
			this.searchBtnClick();
		} else {
			this.comp("messageDialog").show({
				title : "提示",
				message : "只有保存状态的记录可以删除！"
			});
			return;
		}

	};

	Model.prototype.printBtnClick = function(event) {
		var fTestOrgCode = this.comp("selectData").getValue("sCode");
		var result = this.ognCheck();
		if (!result) {
			return;
		}
		var showData = this.comp("VIEW_LIMS_CHECK_ENTRUSTMENT");
		var row = showData.getCurrentRow();
		if (row == undefined) {
			justep.Util.hint("请先选择一条数据", {
				type : 'info',
				"delay" : 3000
			});
			return;
		}

		var id = row.val("FID");
		var mainData = this.comp("mainData");
		var testItemData = this.comp("testItemData");
		mainData.clear();
		mainData.setFilter("IDFilter", "LIMS_Check_EntrustmentMain = '" + id + "'");
		mainData.refreshData();
		var printData1 = this.comp("printData1");
		var printData2 = this.comp("printData2");
		var printData3 = this.comp("printData3");
		printData1.clear();
		printData2.clear();
		printData3.clear();
		// 这里需要再增加子表的数据，需要根据样品编号，查出所有这个样品编号相关的委托单信息
		var context = this.getContext();

		if (mainData.getValue("fState") >= 2) {
			var arrM = [];
			var arr1 = [];
			var arrM3 = [];
			var testType = mainData.getValue("fTestType");
			var row1 = mainData.getCurrentRow();

			var erpNo = row1.val('fSampleID');
			var fSampleID = "";
			if (erpNo == undefined || erpNo == "") {
				// 这是什么意思？
				fSampleID = row1.val('fModelType');
			} else {
				// 这是什么意思？
				fSampleID = erpNo + "/" + row1.val('fModelType')
			}
			testItemData.setFilter("idFilter", "LIMS_Check_CheckItemSub.fEntrustmentNo ='" + id + "'");
			testItemData.refreshData();
			var finalSampleCodeMap = new Map();
			var finalSampleBatchNo;
			var fTestItemName;
			debugger
			testItemData.each(function(param) {
				finalSampleBatchNo = param.row.val("fFinalSampleBatchNo");
				fTestItemName = param.row.val("fTestItemName");

				// if (finalSampleBatchNo != undefined && finalSampleBatchNo !=
				// "") {
				var finalSampleBatchNoArry = finalSampleBatchNo.split(' ');
						debugger
				for (var i = 0; i < finalSampleBatchNoArry.length; i++) {
					
					// finalSampleCodeMap-存放合并后的样品编号
					// finalSampleCodeMap.set(finalSampleBatchNoArry[i],
					// finalSampleBatchNoArry[i]);
					finalSampleBatchNo = finalSampleBatchNoArry[i];
					var date = justep.Date.toString(new Date(), justep.Date.STANDART_FORMAT_SHOT);

					// 需要判断是否有原样品编号，有原样品编号的，需要使用原样品编号进行查询相关的委托单信息

					// 列出所有同一个样品的委托单信息及申请人，检测项目

					var result = check.queryAllEntrustmentBySampleCode(finalSampleBatchNo, context);
					var originalSampleNo = finalSampleBatchNo;
							debugger
					for (var j = 0; j < result.length; j++) {
						// 填充子表信息

						var originalSampleNoTemp = result[j].originalSampleNo;
						if (originalSampleNoTemp != null && originalSampleNoTemp != undefined && originalSampleNoTemp != "") {
							originalSampleNo = originalSampleNoTemp;
						}
						arr3 = {
							"fSampleNo" : originalSampleNo,
							"fEntrustmentNo" : result[j].fEntrustmentNo,
							"fCreatePsnName" : result[j].fCreatePsnName,
							"testName" : result[j].testName
						};
						arrM3.push(arr3);
					}

					// 如果是上海银轮，直接用理化的
					if (fTestOrgCode == "ZXGS") {
						if (testType == 1) { // 理化检测
							arr1 = {
								"fSampleNo" : finalSampleBatchNo,
								"barcode" : row1.val('fEntrustmentNo') + "*" + finalSampleBatchNo,
								"fEntrustmentNo" : row1.val('fEntrustmentNo'),
								"fClientUnit" : row1.val('fClientUnit'),
								"fSampleID" : fSampleID,
								"fSampleName" : row1.val('fSampleName'),
								"fTestItemName" : fTestItemName,
								"fModelType" : row1.val('fModelType'),
								"fBrandName" : row1.val('fBrandName'),
								"fPrintDate" : date
							};

						} else { // 试验检测和发动机检测
							var fSampleHandleType = row1.val('fSampleHandleType');
							if (fSampleHandleType == 0) {
								fSampleHandleType = "客户取回(实验完成3个工作日内取回)";
							} else if (fSampleHandleType == 1) {
								fSampleHandleType = "留样3个月";
							} else if (fSampleHandleType == 2) {
								fSampleHandleType = "报废";
							}

							arr1 = {
								"fSampleNo" : finalSampleBatchNo,
								"barcode" : row1.val('fEntrustmentNo') + "*" + finalSampleBatchNo,
								"fEntrustmentNo" : row1.val('fEntrustmentNo'),
								"fClientUnit" : row1.val('fClientUnit'),
								"fContactTelephone" : row1.val('fContactTelephone') + row1.val('fContactName'),
								"fSampleID" : fSampleID,
								"fSampleName" : row1.val('fSampleName'),
								"fTestItemName" : fTestItemName,
								"fModelType" : row1.val('fModelType'),
								"fSampleHandleType" : fSampleHandleType,
								"fPrintDate" : date
							};
						}

					} else {
						arr1 = {
							"fSampleNo" : originalSampleNo,
							"fSampleName" : row1.val('fSampleName')
						};
					}
					arrM.push(arr1);
				}
				// }
			});

			var param = {
				defaultValues : arrM
			};
			var param3 = {
				defaultValues : arrM3
			};

			if (fTestOrgCode == "ZXGS") {
				if (testType == 1) { // 理化检测
					printData2.newData(param);
					printData2.refreshData();
					this.comp("report2").refresh();
					this.comp("report2").print();
				} else {
					printData1.newData(param);
					printData1.refreshData();
					this.comp("report1").refresh();
					this.comp("report1").print();
				}

			} else {
				printData1.newData(param);
				printData1.refreshData();
				printData3.newData(param3);
				printData3.refreshData();
				this.comp("report3").refresh();
				this.comp("report3").print();
			}

		} else {
			this.comp("messageDialog").show({
				title : "提示",
				message : "只有审批完成的记录可以打印标签！"
			});
			return;
		}
	};

	Model.prototype.loadBtnClick = function(event) {

	};

	Model.prototype.flowBtnClick = function(event) {
		var result = this.ognCheck();
		if (!result) {
			return;
		}
		var process = this.comp("process1");
		var showData = this.comp("VIEW_LIMS_CHECK_ENTRUSTMENT");
		var row = showData.getCurrentRow();
		if (row == undefined) {
			justep.Util.hint("请先选择一条数据", {
				type : 'info',
				"delay" : 3000
			});
			return;
		}
		var fid = row.val("FID");
		if (fid != "" && fid != undefined) {
			// LIMS\Check\process\EntrustmentApply\entrustmentApplyProcess
			process.showChart("/LIMS/Check/process/EntrustmentApply/entrustmentApplyProcess", fid, null);
		} else {
			justep.Util.hint("请先选择一条数据", {
				type : 'info',
				"delay" : 3000
			});
			return;
		}

	};

	Model.prototype.testItemBtnClick = function(event) {

		var result = this.ognCheck();
		if (!result) {
			return;
		}
		var selectRow = this.comp('selectData').getCurrentRow();
		var ognCode = selectRow.val("sCode");
		var row = this.comp('searchData').getCurrentRow();
		this.comp("testItemDialog").open({
			data : {
				"type" : "new",
				"ognCode" : ognCode,
				"row" : row
			}
		});
	};

	Model.prototype.searchBtnClick = function(event) {
	
		var result1 = this.ognCheck();
		if (!result1) {
			return;
		}
		//var showData = this.comp("showData");
		var searchData = this.comp("searchData");
		var selectRow = this.comp('selectData').getCurrentRow();
	

		// int queryType = 0;// 查询类型0-委托单申请查询2-委托单审批查询1-委托管理查询3-委托单查看页面查询

		var testTypeID = searchData.getValue("testTypeID");// 检测类型id 0-试验 1-理化
		// 2-发动机
		var entrustmentNo = searchData.getValue("entrustmentNo");// 委托单号
		var erpNo = searchData.getValue("erpNo");// erp编号
		var sampleName = searchData.getValue("sampleName");// 样品名称
		var startDate = searchData.getValue("startDate");// 单据开始日期
		var endDate = searchData.getValue("endDate");// 单据结束日期
		var fTestItemCode = searchData.getValue("fTestItemCode");// 检测项目编码
		var state = searchData.getValue("state");// 单据状态
		var customerName = searchData.getValue("customerName");// 客户名称
		var isFiled = searchData.getValue("isFiled");// 是否归档
		var fileNo = searchData.getValue("fileNo");// 归档号
		var applyPsnName = searchData.getValue("applyPsnID");// 申请人姓名
		var isCNAS = searchData.getValue("isCNAS");// 是否CNAS
		var isCMA = searchData.getValue("isCMA");// 是否CMA
		var fSampleItemName = searchData.getValue("fSampleItemName");// 项目名称
		var modelType = searchData.getValue("modelType");// 规格型号
		var fBrandName = searchData.getValue("fBrandName");// 牌号/状态
		var fClientReportType = searchData.getValue("clientReport");// 客户报告类型
		
		var filter = " 1=1 ";
		var begin2vaild = false;
		var end2vaild = false;
		var r = new RegExp("^[1-2]\\d{3}-(0?[1-9]||1?[0-2])-(0?[1-9]||[1-2][0-9]||3[0-1])$");
		var VIEW_LIMS_CHECK_ENTRUSTMENT = this.comp("VIEW_LIMS_CHECK_ENTRUSTMENT");

		if (entrustmentNo == undefined || entrustmentNo == "") {
			entrustmentNo = null;
		} else {
			entrustmentNo = entrustmentNo.replace(/\s*/g, "");
			filter += " AND (FENTRUSTMENTNO like '%" + entrustmentNo + "%' or FOTHEREXPLAIN like '%" + entrustmentNo + "%')";
		}

		if (applyPsnName == undefined || applyPsnName == "") {
			applyPsnName = null;
		} else {
			applyPsnName = applyPsnName.replace(/\s*/g, "");
			filter += " AND FCREATEPSNNAME like '%" + applyPsnName + "%'";
		}

		if (erpNo == undefined || erpNo == "") {
			erpNo = null;
		} else {
			var value = this.splitString(erpNo);

			filter += "AND FSAMPLEID " + value;
		}

		if (sampleName == undefined || sampleName == "") {
			sampleName = null;
		} else {
			sampleName = sampleName.replace(/\s*/g, "");
			filter += " AND FSAMPLENAME like '%" + sampleName + "%'";
		}

		if (fileNo == undefined || fileNo == "") {
			fileNo = null;
		} else {
			fileNo = fileNo.replace(/\s*/g, "");
			filter += " AND FFILENO like '%" + fileNo + "%'";
		}

		if (isFiled == undefined || isFiled == "") {
			isFiled = null;
		} else {
			if (isFiled == 0) {
				filter += " AND (FISFILED = '" + isFiled + "' or FISFILED is null)";
			} else {
				filter += " AND FISFILED = '" + isFiled + "'";
			}

		}

		if (state == undefined || state == "") {
			state = null;
		} else {
				if(state.indexOf("等待检测委托单中（审批完成）")!=-1){
				state = state+"，审批完成";
				}
			var value = this.splitString(state);

			filter += "AND STATE " + value;
		}

		//客户名称
		if (customerName == undefined || customerName == "") {
			customerName = null;
		} else {
			customerName = customerName.replace(/\s*/g, "");
			filter += " AND FCUSTOMERNAME like '%" + customerName + "%'";
		}

		if (isCNAS == undefined || isCNAS == "") {
			isCNAS = null;
		} else {
			
			if (isCNAS == "0 1") {
			} else if (isCNAS == "0") {
				filter += " AND CNASSTATE='否' ";
			} else if (isCNAS == "1") {
				filter += " AND CNASSTATE='是' ";
			}
			// var value = this.splitString(state);
			//
			// filter += "AND STATE " + value;
		}

		//CMA
		if (isCMA == undefined || isCMA == "") {
			isCMA = null;
		} else {
			
			if (isCMA == "0 1") {
			} else if (isCMA == "0") {
				filter += " AND CMASTATE='否' ";
			} else if (isCMA == "1") {
				filter += " AND CMASTATE='是' ";
			}
			// var value = this.splitString(state);
			//
			// filter += "AND STATE " + value;
		}

		var modelType = searchData.getValue("modelType");// 规格型号
		var fBrandName = searchData.getValue("fBrandName");// 牌号/状态
		var fClientReportType = searchData.getValue("clientReport");// 客户报告类型
		
		
		if (modelType != undefined && modelType != "") {
		filter += " AND FMODELTYPE like '%" + modelType + "%'";
		}
	
		if (fBrandName != undefined && fBrandName != "") {
		filter += " AND FBRANDNAME like '%" + fBrandName + "%'";
		}		

		if (fClientReportType != undefined ) {
		if(fClientReportType==""){
		filter += " AND (fClientReportType  = '' or fClientReportType is null )";
		}else if(fClientReportType != "ALL"){
		filter += " AND fClientReportType  = '"+fClientReportType+"'";
		}
		}	




		if (testTypeID == undefined || testTypeID == "") {
			testTypeID = null;
		} else {
			var arry = [];
			arry = testTypeID.split(",");
			for (var i = 0; i < arry.length; i++) {
				if (i == 0) {
					filter += " AND (FTESTTYPE = '" + arry[i] + "'";
				} else {
					filter += " OR FTESTTYPE = '" + arry[i] + "'";
				}
			}
			filter += ")";
		}

		if (fTestItemCode == undefined || fTestItemCode == "") {
			fTestItemCode = null;
		} else {
			var arry1 = [];
			arry1 = fTestItemCode.split(",");
			for (var i = 0; i < arry1.length; i++) {
				if (i == 0) {
					filter += " AND (TESTITEMIDS = '" + arry1[i] + "'";
				} else {
					filter += " OR TESTITEMIDS = '" + arry1[i] + "'";
				}
			}
			filter += ")";
		}

		// 判断设备有效期有效性
		if (startDate != undefined && startDate != "") {
			if (!r.test(startDate)) {
				justep.Util.hint("请填选有效的开始时间或删除开始时间！", {
					type : 'info',
					"delay" : 1500
				});
				return;
			} else {
				begin2vaild = true;
			}
		} else {
			begin2vaild = false;
		}
		if (endDate != undefined && endDate != "") {
			if (!r.test(endDate)) {
				justep.Util.hint("请填选有效的结束时间或删除结束时间！", {
					type : 'info',
					"delay" : 1500
				});
				return;
			} else {
				end2vaild = true;
			}
		} else {
			end2vaild = false;
		}
		if (begin2vaild && end2vaild) {
			if (startDate > endDate) {
				justep.Util.hint("开始时间必须小于结束时间！", {
					type : 'info',
					"delay" : 1500
				});
				return;
			}
		}
		if (begin2vaild) {
			filter += " AND FCREATEDATE >= stringToDate('" + startDate + "')";
		} else {
			startDate = null;
		}
		if (end2vaild) {
			filter += " AND FCREATEDATE <= stringToDate('" + endDate + "')";
		} else {
			endDate = null;
		}
		//项目名称
		if (fSampleItemName == undefined || fSampleItemName == "") {
			fSampleItemName = null;
		} else {
			fSampleItemName = fSampleItemName.replace(/\s*/g, "");
			filter += " AND FSAMPLEITEMNAME like '%" + fSampleItemName + "%'";
		}

		VIEW_LIMS_CHECK_ENTRUSTMENT.setFilter("filter", filter);
		VIEW_LIMS_CHECK_ENTRUSTMENT.refreshData();

		return;
		var allData = this.comp("allData");
		showData.clear();
		allData.clear();
		offset = 1; // 第几条开始显示
		limit = pageListCount; // 第几条结束显示
		dataCount = 0; // 查询数据的总条数
		pageCount = 1; // 当前页码
		var context = this.getContext();
		var result = check.queryLIMS_Check_EntrustmentCus(searchData.toJson(), context);
		if (result.rows.length == 0) {
			justep.Util.hint("搜索条件无数据!", {
				type : 'info',
				"delay" : 3000
			});
			this.comp("tempData").setValue("currentRowID", this.comp("showData").getCurrentRowID());
			showData.refreshData();
			return;
		}
		allData.loadData(result);
		// 显示数据
		dataCount = result.rows.length;
		// 获取当前页码
		getPageNum(this);
		// 获取显示数据
		showData.loadData(getDataTable(this));
		showData.refreshData();
		this.comp('grid1').refresh();
		this.comp("tempData").setValue("currentRowID", this.comp("showData").getCurrentRowID());

	};

	Model.prototype.splitString = function(value) {

		var arry = value.split(",");
		var sql = " in (";
		for (var i = 0; i < arry.length; i++) {
			sql += "'" + arry[i] + "',";
		}
		sql = sql.substring(0, sql.length - 1) + ") ";
		return sql;
	};

	Model.prototype.ognCheck = function() {
		var ognName = this.comp('select2').val();
		if (ognName == undefined) {
			this.comp("messageDialog").show({
				title : "提示",
				message : "请先选择组织名称！"
			});
			return false;
		}
		return true;
	};

	Model.prototype.modelParamsReceive = function(event) {
	var searchData = this.comp("searchData");
		var ognSelectData = this.comp('ognSelectData');
		var context = this.getContext();
		var ognCode = context.getCurrentOgnCode();// 当前用户机构编码
		var psnID = context.getCurrentPersonID();// 当前用户ID
		var result = org.queryLabOrgList(psnID, ognCode, "", this.getContext());
		ognSelectData.loadData(result);
		ognSelectData.refreshData();
		searchData.setValue("clientReport", "ALL");
		// searchData.setValue("stateID", 0);
		// searchData.setValue("state", "保存");// 0-
		// 保存，1-审核中，2-等待检测委托单中（审核完成），3-已终止，4-检测中，5-检测完成，6-报告已完成,7-驳回
		if (ognSelectData.getCount() > 0) {
			var endDate = justep.Date.toString(new Date(), justep.Date.STANDART_FORMAT_SHOT);
			var startDate = justep.Date.toString(justep.Date.decrease(new Date(), 1, "w"), justep.Date.STANDART_FORMAT_SHOT);
			var searchData = this.comp('searchData');
			searchData.setValue("startDate", startDate);
			searchData.setValue("endDate", endDate);
			searchData.setValue("queryType", 3);// 查询类型0-委托单申请查询1-3个科室审批页面查询2-部门领导委托单审批查询3-委托管理查询
			var selectData = this.comp('selectData');
			var rows = ognSelectData.find([ 'SCODE' ], [ ognCode ], false, false, false);
			if (rows.length > 0) {
				this.comp("select2").val(rows[0].val("SCODE"));
				selectData.setValue("sCode", rows[0].val("SCODE"));
				selectData.setValue("sName", rows[0].val("SNAME"));
			} else {
				this.comp("select2").val(ognSelectData.getValue("SCODE"));
				selectData.setValue("sCode", ognSelectData.getValue("SCODE"));
				selectData.setValue("sName", ognSelectData.getValue("SNAME"));
			}
			this.comp("report1")._config.page.pageWidth = "60mm"; // 设置纸张宽度
			this.comp("report1")._config.page.pageHeight = "40mm"; // 设置纸张高度
			this.comp("report1")._config.page.marginLeft = "0mm";// 设置纸张左边距
			this.comp("report1")._config.page.marginRight = "0mm";// 设置纸张右边距
			this.comp("report1")._config.page.marginTop = "0mm";// 设置纸张上边距
			this.comp("report1")._config.page.marginBottom = "0mm";// 设置纸张下边距
	
			this.comp("report2")._config.page.pageWidth = "80mm"; // 设置纸张宽度
			this.comp("report2")._config.page.pageHeight = "60mm"; // 设置纸张高度
			this.comp("report2")._config.page.marginLeft = "0mm";// 设置纸张左边距
			this.comp("report2")._config.page.marginRight = "0mm";// 设置纸张右边距
			this.comp("report2")._config.page.marginTop = "0mm";// 设置纸张上边距
			this.comp("report2")._config.page.marginBottom = "0mm";// 设置纸张下边距
			this.select2Change();
		}else{
			alert("无实验组织无法使用该功能");
		}
		
	};

	Model.prototype.mainFormDialogReceive = function(event) {
		var fTestOrgCode=this.comp("selectData").getValue("sCode");
		var fTestOrgName=this.comp("selectData").getValue("sName");
		var type = event.data.type;
		if (type == "refreshData") {
			this.searchBtnClick();
		}

	};

	Model.prototype.erpMultiBtnClick = function(event) {
		this.comp("ERPMultiDialog").open({
			data : {
				"type" : "new"
			}
		});
	};

	Model.prototype.ERPMultiDialogReceive = function(event) {
		var data = event.data;
		var ERPID;
		for (var i = 0; i < data.length; i++) {
			if (i == 0) {
				ERPID = data[i].val('ERPID');
			} else {
				ERPID = ERPID + "," + data[i].val('ERPID');
			}
		}
		var searchData = this.comp('searchData');
		searchData.setValue("erpNo", ERPID);
	};

	Model.prototype.select2Change = function(event) {
	
	var fTestOrgCode = this.comp("selectData").getValue("sCode");
	this.comp("VIEW_LIMS_CHECK_ENTRUSTMENT").setFilter("orgFilter","VIEW_LIMS_CHECK_ENTRUSTMENT.FTESTORGCODE ='"+fTestOrgCode+"'");
	this.searchBtnClick();
	this.comp("tempData").setValue("currentRowID", this.comp("VIEW_LIMS_CHECK_ENTRUSTMENT").getCurrentRowID());
	return;
	
		var selectRow = this.comp('selectData').getCurrentRow();
		var fTestOrgCode = selectRow.val("sCode");
		var searchData = this.comp("searchData");
		searchData.setValue("fTestOrgCode", fTestOrgCode);

		var showData = this.comp("showData");
		var allData = this.comp("allData");
		showData.clear();
		allData.clear();
		offset = 1; // 第几条开始显示
		limit = pageListCount; // 第几条结束显示
		dataCount = 0; // 查询数据的总条数
		pageCount = 1; // 当前页码
		var context = this.getContext();
		var result = check.queryLIMS_Check_EntrustmentCus(searchData.toJson(), context);
		if (result.rows.length === 0) {
			justep.Util.hint("搜索条件无数据!", {
				type : 'info',
				"delay" : 3000
			});
			return;
		}
		allData.loadData(result);
		// 显示数据
		dataCount = result.rows.length;
		// 获取当前页码
		getPageNum(this);
		// 获取显示数据
		showData.loadData(getDataTable(this));
		showData.refreshData();
		this.comp("tempData").setValue("currentRowID", this.comp("VIEW_LIMS_CHECK_ENTRUSTMENT").getCurrentRowID());
	};

	Model.prototype.grid1RowClick = function(event) {
		this.comp("tempData").setValue("currentRowID", this.comp("VIEW_LIMS_CHECK_ENTRUSTMENT").getCurrentRowID());

		
		var showData = this.comp("VIEW_LIMS_CHECK_ENTRUSTMENT");
		var mainData = this.comp("mainData");
		// this.comp("tempData").setValue("currentRowID",
		// showData.getCurrentRowID());
		if (viewflag) {
			viewflag = false;
			var ognCode = this.comp("select2").val();
			var row = showData.getCurrentRow();
			var fid = row.val("FID");
			var entrustmentNo = row.val("FENTRUSTMENTNO");
			var isReport = row.val("FREPORTTYPE");
			
			mainData.setFilter("IDFilter", "LIMS_Check_EntrustmentMain = '" + fid + "'");
			mainData.refreshData();
			var isReported = mainData.getValue("fIsReported");
			this.comp("testItemDetailDialog").open({
				data : {
					"fid" : fid,
					"entrustmentNo" : entrustmentNo,
					"isReport" : isReport,
					"isReported" : isReported,
					"ognCode" : ognCode
				}
			});
		}
	};

	Model.prototype.view = function(event) {
		viewflag = true;
	};

	Model.prototype.lastBtnClick = function(event) {
		var showData = this.comp("showData");
		if (showData.getCount() > 0) {
			if (Math.ceil(dataCount / pageListCount) == pageCount) {
				// alert("当前页已经是第后一页!");
				justep.Util.hint("当前页已经是第后一页!", {
					type : 'info',
					"delay" : 3000
				});
				return;
			} else {
				offset = (Math.ceil(dataCount / pageListCount) - 1) * pageListCount;
				limit = (Math.ceil(dataCount / pageListCount)) * pageListCount;
				pageCount = Math.ceil(dataCount / pageListCount);
				showData.loadData(getDataTable(this));
				showData.refreshData();
			}
		}
	};

	Model.prototype.nextBtnClick = function(event) {
		var showData = this.comp("showData");
		if (showData.getCount() > 0) {
			if (Math.ceil(dataCount / pageListCount) == pageCount) {
				// alert("当前页已经是第后一页!");
				justep.Util.hint("当前页已经是第后一页!", {
					type : 'info',
					"delay" : 3000
				});
				return;
			} else {
				limit = limit + pageListCount;
				offset = pageListCount + offset;
				pageCount = pageCount + 1;
				showData.loadData(getDataTable(this));
				showData.refreshData();
			}
		}
	};

	Model.prototype.preBtnClick = function(event) {
		var showData = this.comp("showData");
		if (showData.getCount() > 0) {
			if (pageCount == 1) {
				// alert("当前页已经是第一页!");
				justep.Util.hint("当前页已经是第一页!", {
					type : 'info',
					"delay" : 3000
				});
				return;
			} else {
				limit = limit - pageListCount;
				pageCount = pageCount - 1;
				offset = offset - pageListCount;
				showData.loadData(getDataTable(this));
				showData.refreshData();
			}
		}
	};

	Model.prototype.firstBtnClick = function(event) {
		var showData = this.comp("showData");
		if (showData.getCount() > 0) {
			if (pageCount == 1) {
				// alert("当前页已经是第一页!");
				justep.Util.hint("当前页已经是第一页!", {
					type : 'info',
					"delay" : 3000
				});
				return;
			} else {
				offset = 1;
				limit = pageListCount;
				pageCount = 1;
				showData.loadData(getDataTable(this));
				showData.refreshData();
			}
		}
	};
	// 当前页显示的数据
	function getDataTable(my) {
		// 每次显示之前清空临时数据表data1
		var showData = my.comp("showData");
		showData.clear();
		// 在grid中显示当前页的数据
		var arr = [];
		var tempCount = 0;
		if (dataCount < limit) {
			tempCount = dataCount;
		} else {
			tempCount = limit;
		}
		var allData = my.comp("allData");
		// 获取数据Data的字段
		var Columns = showData.getColumnIDs();
		Columns = Columns.split(",");
		// 给字段赋值
		for (var i = offset - 1; i < tempCount; i++) {
			var arr1 = [];
			for (var j = 0; j < Columns.length; j++) {
				var columnName = Columns[j];
				var columnVlaue = allData.getValue(columnName, allData.getRowByID(i + 1));
				arr1[columnName] = columnVlaue;
			}
			arr.push(arr1);
		}
		getPageNum(my);
		return arr;
	}
	// 获取当前页码
	function getPageNum(my) {
		$(my.getElementByXid("labelPage")).text("每页20条/共" + dataCount + "条   当前第" + pageCount + "页/共" + Math.ceil(dataCount / pageListCount) + "页");
	}

	Model.prototype.testItemDialogReceive = function(event) {
		var data = event.data;
		var sCode;
		var sName;
		for (var i = 0; i < data.length; i++) {
			if (i == 0) {
				sCode = data[i].val('fItemCode');
				sName = data[i].val('ITEMNAME');
			} else {
				sCode = sCode + "," + data[i].val('fItemCode');
				sName = sName + "," + data[i].val('ITEMNAME');
			}
		}
		var searchData = this.comp("searchData");
		searchData.setValue("fTestItemCode", sCode);
		searchData.setValue("testItemName", sName);
	};

	Model.prototype.resetBtnClick = function(event) {
		var searchData = this.comp("searchData");
		searchData.clear();
		searchData.newData();
		searchData.setValue("clientReport", "ALL");
		searchData.setValue("queryType", 3);// 查询类型0-委托单申请查询1-3个科室审批页面查询2-部门领导委托单审批查询3-委托管理查询
		// searchData.setValue("stateID", 0);
		// searchData.setValue("state", "保存");// 0-
		// 保存，1-审核中，2-等待检测委托单中（审核完成），3-已终止，4-检测中，5-检测完成，6-报告已完成

	};

	// Model.prototype.circulationBtnClick = function(event) {
	// var result = this.ognCheck();
	// if (!result) {
	// return;
	// }
	// var taskData = this.comp("taskData");
	// var showData = this.comp("showData");
	// var mainData = this.comp("mainData");
	// var row = showData.getCurrentRow();
	// var rowid = row.val("FID");
	// // var data = this.comp("mainData");
	// // var rowid = data.getCurrentRowID();
	// var context = this.getContext();
	// var currentPersonID = context.getCurrentPersonID();
	// var filter = "SA_Task.sData1 = '" + rowid + "' and
	// (SA_Task.sStatusID='tesReady' or SA_Task.sStatusID='tesExecuting') and
	// (SA_Task.sTypeID IS NULL or SA_Task.sTypeID <> 'WORKREMIND')and"
	// + " SA_Task.sActivityInTemplate ='businessActivity2'and
	// sExecutorPersonID='" + currentPersonID + "'";
	// taskData.setFilter("filter1", filter);
	// taskData.refreshData();
	// // var count =task.getCount();
	// var sActivity = taskData.getValue("sActivity");
	// 
	//
	// if (sActivity == 'businessActivity2') {
	// var title = taskData.getValue("sActivityName");// 获得当前环节名称，作为页面的标题
	// var taskID = taskData.getValue("SA_Task");// 获得任务ID，url中的参数
	// var url = taskData.getValue("sEURL");// 获得当前环节的url
	// url = url + "?task=" + taskID + "&_pagePattern=write";//
	// _pagePattern=write是必须的，表示要处理这个任务
	// var executorPersonID = taskData.getValue("sExecutorPersonID");
	// if (executorPersonID === currentPersonID) {// 如果执行者是否当前人
	// justep.Shell.showPage({
	// url : url,
	// title : title
	// }, {
	// data : {
	// "type" : "Activity"
	// }
	// }); // 调用justep.Shell.showPage方法打开流程当前环节对应的w文件
	// } else {
	// alert("您不是当前执行人，无法处理！");
	// }
	// } else {
	// alert("您不是当前执行人，无法处理！");
	// }
	// };

	Model.prototype.filedBtnClick = function(event) {

		var result = this.ognCheck();
		if (!result) {
			return;
		}
		var currentRowID = this.comp("tempData").getValue("currentRowID");
		if (currentRowID == "" || currentRowID == undefined) {
			this.comp("messageDialog").show({
				title : "提示",
				message : "请先选择一条数据！"
			});
			return;
		}
		
		var row = this.comp("VIEW_LIMS_CHECK_ENTRUSTMENT").getCurrentRow();
		var id = row.val("FID");
		// var myTaskData = this.comp("myTaskData");// 我的检测任务data
		// myTaskData.setFilter("idFilter",
		// "VIEW_LIMS_CHECK_MYTASK.FENTRUSTMENTNO ='" + id + "'");
		// myTaskData.refreshData();
		// alert(myTaskData.getCount());
		var sampleSubData = this.comp("sampleSubData");
		// 每个样件的试验数据全部审核完才能归档，已终止和已取消的算数据审核完成
		// 实验状态0-未开始1-实验中2-申请取消中3-已取消4-驳回申请人5-申请暂停6-已暂停7-实验结束8-已终止
		// fTestDataAuitState 数据审核 0-未审核 1-已审核
		sampleSubData.setFilter("IDFilter", "LIMS_Check_CheckItemSampleSub.fEntrustmentNo = '" + id
				+ "' and LIMS_Check_CheckItemSampleSub.fTestDataAuitState = 0  and LIMS_Check_CheckItemSampleSub.fTestState <> 3 and LIMS_Check_CheckItemSampleSub.fTestState <> 8");
		sampleSubData.refreshData();
		if (sampleSubData.getCount() > 0) {
			this.comp("messageDialog").show({
				title : "提示",
				message : "试验数据全部审核完才能归档！"
			});
			return;
		}
		this.comp("filedDialog").open({
			data : {
				"fid" : id
			}
		});
	};

	Model.prototype.grid1RowDblClick = function(event) {
		var row = this.comp("VIEW_LIMS_CHECK_ENTRUSTMENT").getCurrentRow();
		var selectRow = this.comp('selectData').getCurrentRow();
		this.comp("viewMainDialog").open({
			data : {
				"row" : row,
				"selectRow" : selectRow
			}
		});

	};

	Model.prototype.modelActive = function(event) {
		this.searchBtnClick();
	};

	Model.prototype.abortBtnClick = function(event) {
		var result = this.ognCheck();
		if (!result) {
			return;
		}
		var currentRowID = this.comp("tempData").getValue("currentRowID");
		if (currentRowID == "" || currentRowID == undefined) {
			this.comp("messageDialog").show({
				title : "提示",
				message : "请先选择一条数据！"
			});
			return;
		}
		var row = this.comp("VIEW_LIMS_CHECK_ENTRUSTMENT").getCurrentRow();
		var id = row.val("FID");

		this.comp("abortReasonDialog").open({
			data : {
				"fid" : id
			}
		});
	};

	// Model.prototype.button1Click = function(event) {
	//
	// var result = this.ognCheck();
	// if (!result) {
	// return;
	// }
	// var currentRowID = this.comp("tempData").getValue("currentRowID");
	// if (currentRowID == "" || currentRowID == undefined) {
	// this.comp("messageDialog").show({
	// title : "提示",
	// message : "请先选择一条数据！"
	// });
	// return;
	// }
	// var row = this.comp("showData").getCurrentRow();
	// var id = row.val("FID");
	//
	// this.comp("testItemDetailDialog").open({
	// data : {
	// "fid" : id
	// }
	// });
	// };

	Model.prototype.grid1CellRender = function(event) {
		if (event.colName == "FID") {
			event.html = "<button class='btn btn-default btn-link btn-sm viewbtn' onclick='justep.Util.getModel(this).view(event)'>  查看安排  </button>"
		}
	};

	Model.prototype.viewBtnClick = function(event) {

		var result = this.ognCheck();
		if (!result) {
			return;
		}
		var data = this.comp("VIEW_LIMS_CHECK_ENTRUSTMENT");
		var row = data.getCurrentRow();
		if (row == undefined) {
			justep.Util.hint("请先选择一条数据", {
				type : 'info',
				"delay" : 3000
			});
			return;
		}
		var id = row.val("FID");
		var mainData = this.comp("mainData");
		var testItemData = this.comp("testItemData");
		var sampleSubData = this.comp("sampleSubData");
		var entrustmentCustSubData = this.comp("entrustmentCustSubData");

		mainData.setFilter("IDFilter", "LIMS_Check_EntrustmentMain = '" + id + "'");
		mainData.refreshData();
		debugger
		if (mainData.getValue("fState") == 2) {
			testItemData.setFilter("idFilter", "LIMS_Check_CheckItemSub.fEntrustmentNo ='" + id + "'");
			testItemData.refreshData();
			mainData.setValue("data1", testItemData.toJson());
			sampleSubData.setFilter("idFilter", "LIMS_Check_SampleSub.fEntrustmentNo ='" + id + "'");
			sampleSubData.refreshData();
			mainData.setValue("data2", sampleSubData.toJson());
			entrustmentCustSubData.setFilter("idFilter", "LIMS_Check_EntrustmentCustSub.fEntrustmentNo ='" + id + "'");
			entrustmentCustSubData.refreshData();
			mainData.setValue("data3", entrustmentCustSubData.toJson());
		}
		var param = JSON.stringify(mainData.toJson());
		// openPostWindow(encodeURI('http://192.168.89.42:8086/yl_pageoffice_web/lims/check/entrustment/index?type=openWord'),
		// "我是标题", "0", id);
		// openPostWindow(encodeURI('http://127.0.0.1:8086/lims/check/entrustment/index?type=openWord'),
		// "我是标题", "0", id);
		// 理化检测 发动机检测 理化检测

		var selectKind = data.getValue("FID");
		var testType = data.getValue("TESTTYPE");
		var STATE = data.getValue("STATE");// 审批状态
		var FSTATE = data.getValue("FSTATE");// 审批状态
		var code = data.getValue("FENTRUSTMENTNO");// 委托单号
		var fTestOrgCode =data.getValue("FTESTORGCODE");
		
		if (FSTATE >= 2 && FSTATE != 7) {
		if(fTestOrgCode=="ZXGS"){
					if (testType == "理化检测") {
				this.comp("printLH").open({
					data : {
						"selectKind" : selectKind,
						"code" : code,
						"fTestOrgCode":fTestOrgCode
					}
				});
			} else {
				this.comp("printFDJ").open({
					data : {
						"selectKind" : selectKind,
						"code" : code,
						"fTestOrgCode":fTestOrgCode
					}
				});
			}
		}else{
					if (testType == "理化检测") {
				this.comp("printLHSH").open({
					data : {
						"selectKind" : selectKind,
						"code" : code,
						"fTestOrgCode":fTestOrgCode
					}
				});
			} else {
				this.comp("printFDJSH").open({
					data : {
						"selectKind" : selectKind,
						"code" : code,
						"fTestOrgCode":fTestOrgCode
					}
				});
			}
		}

		} else {
			alert("委托单未审核完成，无法打印！");
		}

	};

	Model.prototype.abortReasonDialogReceive = function(event) {
		
		var data = event.data;
		if (data == "success") {
			var showData = this.comp("VIEW_LIMS_CHECK_ENTRUSTMENT");
			var taskData = this.comp("taskData");
			var row = showData.getCurrentRow();
			var id = row.val("FID");
			var taskData = this.comp("taskData");
			var context = this.getContext();
			var currentPersonID = context.getCurrentPersonID();
			var filter = "SA_Task.sData1 = '" + id + "' and (SA_Task.sStatusID='tesReady' or SA_Task.sStatusID='tesExecuting') and (SA_Task.sTypeID IS NULL or SA_Task.sTypeID <> 'WORKREMIND')and"
					+ " SA_Task.sActivityInTemplate is not null and sExecutorPersonID='" + currentPersonID + "'";
			taskData.setFilter("filter1", filter);
			taskData.refreshData();
			if (taskData.getCount() > 0) {
				var process = this.comp("process1");
				var taskID = taskData.getValue("SA_Task");// 获得任务ID，url中的参数
				process.abortExt(taskID);
			}
			this.searchBtnClick();
		}

	};

	Model.prototype.filedDialogReceive = function(event) {
		this.searchBtnClick();

	};

	var formConceal = false;
	Model.prototype.checkBtnClick = function(event){

		var form2 =  this.getElementByXid('form2');
		
		if(formConceal){
			
			//显示
			form2.style.display = 'block';
			
			formConceal = false;
		
		}else{
		
			//隐藏
			form2.style.display = 'none';
			
			formConceal = true;
			
		
		}

	};

	Model.prototype.print2BtnClick = function(event){

		var result = this.ognCheck();
		if (!result) {
			return;
		}
		var showData = this.comp("VIEW_LIMS_CHECK_ENTRUSTMENT");
		var row = showData.getCurrentRow();
		if (row == undefined) {
			justep.Util.hint("请先选择一条数据", {
				type : 'info',
				"delay" : 3000
			});
			return;
		}
		var fSubpackageTestName = row.val("FSUBPACKAGETESTNAME");//分包实验室
		if(fSubpackageTestName == undefined || fSubpackageTestName == ""){
			justep.Util.hint("只能对分包委托单进行分包打印", {
				type : 'info',
				"delay" : 3000
			});
			return;
		}
		
		var FFSECONDSTATE = row.val("FFSECONDSTATE");//委托单的第二中状态
		
//		if(FFSECONDSTATE != "2"){
//			justep.Util.hint("只能对已审批完成的数据进行分包打印", {
//				type : 'info',
//				"delay" : 3000
//			});
//			return;	
//		}
		
		var fid = row.val("FID");
		if (fid != "" && fid != undefined) {
			
			//打开分包打印页面 /LIMS/Check/process/EntrustmentApply/entrustmentApplyProcess
			this.comp("printDialog").open({
				data : {
					"task" : null,
					"process" : "/LIMS/Check/process/EntrustmentApply/entrustmentApplyProcess",
					"data" : fid
				}
			});
		
		} else {
			justep.Util.hint("请先选择一条数据", {
				type : 'info',
				"delay" : 3000
			});
			return;
		}

	};

	return Model;
});